server {
  server_name *.testing.{{ sutty }};

  access_log syslog:server=unix:/tmp/access_log.socket,nohostname access_logd;

{% if inventory_hostname in groups.sutty_certbot %}
  include snippets/acme.conf;
{% else %}
  # Redirect to "Central Validation Server"
  location ^~ /.well-known/acme-challenge/ {
    return 301 http://certbot.{{ sutty }}$request_uri;
  }
{% endif %}

  listen 80;
  listen 443 ssl;
  http2 on;

  add_header X-Robots-Tag "none";
  add_header Cache-Control no-cache;
  add_header Strict-Transport-Security "max-age=31536000; includeSubDomains; preload";
  add_header X-Frame-Options "sameorigin";
  add_header X-XSS-Protection "1; mode=block";
  add_header X-Content-Type-Options "nosniff";
  add_header Referrer-Policy "strict-origin-when-cross-origin";
  add_header Access-Control-Allow-Origin "*";
  # TODO: Remove panel from media-src
  add_header Content-Security-Policy-Report-Only "default-src 'self'; media-src 'self' {{ panel_env_panel_url }}; style-src 'self' 'unsafe-inline'; script-src https: 'self'; font-src data: 'self'; img-src https: 'self'; object-src 'none'; frame-src https: 'self'; connect-src 'self' https://*.{{ sutty }}; report-uri {{ panel_env_api_url }}/v1/csp_reports.json";
  add_header Permissions-Policy "interest-cohort=()";

  ssl_certificate /etc/letsencrypt/live/{{ sutty }}/fullchain.pem;
  ssl_certificate_key /etc/letsencrypt/live/{{ sutty }}/privkey.pem;
  ssl_session_timeout 1d;
  ssl_session_cache shared:SSL:10m;
  ssl_session_tickets off;
  # Basado en https://ssl-config.mozilla.org/#server=nginx&version=1.22.1&config=intermediate&openssl=3.0.10&guideline=5.7
  ssl_protocols TLSv1.2 TLSv1.3;
  ssl_ciphers ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:DHE-RSA-AES128-GCM-SHA256:DHE-RSA-AES256-GCM-SHA384:DHE-RSA-CHACHA20-POLY1305;
  ssl_early_data on;

  if ($redirect_to_https) {
    return 301 https://$http_host$request_uri;
  }

  location / {
    proxy_set_header X-Forwarded-Proto $scheme;
    proxy_set_header X-Forwarded-Ssl on;
    proxy_set_header X-Forwarded-Port $server_port;
    proxy_set_header X-Forwarded-Host $http_host;
    proxy_set_header Host $http_host;

    set $testing nginx.{{ groups.sutty_panel[0] }}:443;
    proxy_pass https://$testing;
  }
}
